package org.emoflon.neo.example.pac_man;

import static org.hamcrest.core.Is.is;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertThat;

import org.emoflon.neo.api.pacman.API_PacMan;
import org.emoflon.neo.example.ENeoTest;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class PacManPatterns extends ENeoTest {
	private API_PacMan entities = new API_PacMan(builder);
	
	@BeforeEach
	public void initDB() {
		initDB(entities.getModel_SimplePacManGame());
	}
	
	@Test
	public void test_PacManOnField() {
		expectSingleMatch(entities.getPattern_PacManOnField());
	}
	
	@SuppressWarnings("deprecation")
	@Test
	public void test_GhostOnField() {
		assertThat(entities.getPattern_GhostOnField().pattern().countMatches(), is(2));
	}
	
	@Test
	public void test_PacManAndGhostOnNeighbouringFields() {
		expectSingleMatch(entities.getPattern_PacManAndGhostOnNeighbouringFields());
	}
	
	@Test
	public void test_TwoPacManOnBoard() {
		expectNoMatch(entities.getPattern_TwoPacManOnBoard());
	}
	
	@Test
	public void test_Paths() {
		assertEquals(1, entities.getPattern_RelatedFields().pattern().countMatches());
	}
}
