package org.emoflon.neo.emsl.compiler

import org.emoflon.neo.emsl.eMSL.TripleGrammar

class TGGAppGenerator {
	TripleGrammar tgg
	
	new(TripleGrammar tgg) {
		this.tgg = tgg
	}
	
	def generateApp(Operation op, String packagePath, String packageName, String rootAPI) {
		val appName = '''«tgg.name»«op.nameExtension»_Run'''
		val pathPrefix = if(packagePath.nullOrEmpty) "" else '''«packagePath».'''
		'''
			/** 
			 * EMSL-API generated by eMoflon::Neo - Do not edit as this file will be overwritten
			 */
			package «pathPrefix»run;
			
			import org.apache.log4j.Level;
			import org.apache.log4j.Logger;
			import «rootAPI».API_Common;
			import «pathPrefix»API_«packageName»;
			import «pathPrefix»tgg.API_«tgg.name»«op.nameExtension»;
			import org.emoflon.neo.cypher.models.NeoCoreBuilder;
			import org.emoflon.neo.engine.modules.NeoGenerator;
			
			«op.additionalImports(tgg.name, '''«packagePath»''')»
			
			@SuppressWarnings("unused")
			public class «appName» {
				«op.additionalFields(tgg.name)»
				protected static final Logger logger = Logger.getLogger(«appName».class);
				protected String srcModelName;
				protected String trgModelName;
				
				public static void main(String[] args) throws Exception {
					Logger.getRootLogger().setLevel(Level.INFO);
					var app = new «appName»(SRC_MODEL_NAME, TRG_MODEL_NAME);
					app.run();
				}
				
				public «appName»(String srcModelName, String trgModelName) {
					this.srcModelName = srcModelName;
					this.trgModelName = trgModelName;
				}
				
				«op.additionalConstructors(appName)»
				
				public void run() throws Exception {
					try (var builder = API_Common.createBuilder()) {
						«IF op.exportMetamodels»
							new API_«packageName»(builder).exportMetamodelsFor«tgg.name.toFirstUpper»();
						«ENDIF»
				
						var generator = createGenerator(builder);
				
						logger.info("Running generator...");
						generator.generate();
						logger.info("Generator terminated.");
					}
				}
				
				public NeoGenerator createGenerator(NeoCoreBuilder builder) {
					«op.createGeneratorMethodBody(tgg.name, packageName)»
				}
				«op.additionalMethods»
			}
		'''
	}
}
